stages:  
  - build
  - test
  - clean

build:tests:
  stage: build
  script: 
    - python setup.py sdist --dist-dir=build
  artifacts:
    paths:
    - build/clmctest-SNAPSHOT.tar.gz
    expire_in: 1 day

test:
  stage: test
  dependencies: 
    - build:tests
  script: 
    - vagrant --fixture=scripts -- up
    - vagrant --fixture=scripts -- ssh test-runner -- -tt "pip3 install /vagrant/build/$TEST_PACKAGE_NAME"
    - vagrant --fixture=scripts -- ssh test-runner -- -tt "pytest -s --pyargs clmctest.scripts"
    - vagrant --fixture=monitoring -- up
    - vagrant --fixture=monitoring -- ssh test-runner -- -tt "pytest -s --pyargs clmctest.monitoring"  
    - vagrant --fixture=inputs -- up
    - vagrant --fixture=scripts -- ssh test-runner -- -tt "pytest -s --pyargs clmctest.inputs"         
  when: manual   

clean:
  stage: clean
  script: 
    - vagrant --fixture=scripts -- ssh test-runner -- -tt "pip3 uninstall -y clmctest"    
    - vagrant --fixture=inputs -- destroy --force     
    - vagrant --fixture=monitoring -- destroy --force     
    - vagrant --fixture=scripts -- destroy --force
  when: on_failure
